## mingw-w64-moab-5.3.1-3.src.tar.zst

=== pymoab/CMakeLists.txt ===
SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake )

# make sure we have the essential elements installed
FIND_PROGRAM(PYTHON "python")

if(NOT PYTHON)
  FIND_PROGRAM(PYTHON "python3")
endif()

find_package(PythonInterp REQUIRED)
find_package(PythonDev REQUIRED)
# make sure that specific python modules are installed
SET(NUMPY_MODULE_MISSING false)
SET(SETUPTOOLS_MODULE_MISSING false)

EXECUTE_PROCESS(COMMAND "${PYTHON}" "-c" "import numpy" RESULT_VARIABLE NUMPY_MODULE_MISSING)
if (NUMPY_MODULE_MISSING)
  MESSAGE( SEND_ERROR "Python numpy module is missing.")
endif()
EXECUTE_PROCESS(COMMAND "${PYTHON}" "-c" "import setuptools" RESULT_VARIABLE SETUPTOOLS_MODULE_MISSING)
if (SETUPTOOLS_MODULE_MISSING)
  MESSAGE( SEND_ERROR "Python setuptools module is missing.")
endif()

if(MOAB_FORCE_32_BIT_HANDLES)
  MESSAGE( SEND_ERROR "Cannot build pymoab with 32bit EntityHandles enabled. Please remove the --enable-32bit-handles configuration option or build without MOAB's python interface.")
endif()

if(NOT BUILD_SHARED_LIBS)
  MESSAGE( SEND_ERROR "Cannot build static libraries and the python interface. Please build with shared libraries (-DBUILD_SHARED_LIBS=ON) or build without MOAB's python interface.")
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}/pymoab
    ${CMAKE_CURRENT_BINARY_DIR}/pymoab
)

# if all is well go ahead and build/install pymoab interface
if (PYTHON AND NOT PYTHON_MODULES_MISSING)

  ADD_SUBDIRECTORY(pymoab)
  ADD_SUBDIRECTORY(tests)

  #assume a standard install location to start
  SET(PYMOAB_RELATIVE_INSTALL "/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/")
  SET(PYMOAB_USER_INSTALL_LOCATION YES)

if(NOT PYMOAB_PREFIX)
  if(NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    SET(PYMOAB_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    #set custom install indicator to true
    SET(PYMOAB_USER_INSTALL_LOCATION YES)
  else()
    # if no prefix is supplied, install to system location
    SET(PYMOAB_PREFIX "/usr/lib")
    SET(PYMOAB_RELATIVE_INSTALL "/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/")
    SET(PYMOAB_USER_INSTALL_LOCATION NO)
  endif(NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
endif(NOT PYMOAB_PREFIX)

set(PYMOAB_INSTALL_PREFIX "${PYMOAB_PREFIX}/${PYMOAB_RELATIVE_INSTALL}" CACHE FILEPATH "Location of PyMOAB installation" FORCE)

if(PYMOAB_USER_INSTALL_LOCATION)
      MESSAGE(WARNING "\
The PyMOAB interface has been installed to a custom location. \
In order to access this module from a python intpreter, please add \
its install location to the PYTHONPATH environment variable: \
PYTHONPATH=${PYMOAB_INSTALL_PREFIX}/:\$PYTHONPATH \
")
endif()

  # configure the setup script
  SET(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.cmake.in")
  SET(SETUP_PY    "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
  CONFIGURE_FILE(${SETUP_PY_IN} ${SETUP_PY})

  # setup dependencies of the build command
  SET(DEPS   "${CMAKE_CURRENT_SOURCE_DIR}/pymoab/__init__.py")
  SET(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/build")

  # python setuptools build/install local version of pymoab for testing
  ADD_CUSTOM_TARGET(pymoab-local-install ALL
    COMMAND export CFLAGS='-w' &&
    ${PYTHON} setup.py build_ext --inplace
    DEPENDS ${DEPS} MOAB)

  # move pymoab egg into the correct location for a --user setuptools install based on username
  SET(INSTALL_SCRIPT_IN "${CMAKE_CURRENT_SOURCE_DIR}/install.sh.cmake")
  SET(INSTALL_SCRIPT    "${CMAKE_CURRENT_BINARY_DIR}/install.sh")
  CONFIGURE_FILE(${INSTALL_SCRIPT_IN} ${INSTALL_SCRIPT})
  INSTALL(CODE "EXECUTE_PROCESS(COMMAND bash ${INSTALL_SCRIPT})")
#  INSTALL(DIRECTORY ${PYMOAB_PREINSTALL_INSTALL_PATH} DESTINATION ${PYMOAB_INSTALL_PREFIX} )

endif()

=== src/CMakeLists.txt ===
SET(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    parallel
                    io io/mhdf
                    ${MOAB_BINARY_DIR}/src/parallel )

if(MOAB_HAVE_MPI AND MPI_FOUND)
  message(STATUS "Adding parallel subdirectory.")
  add_subdirectory(parallel)
  set( MOAB_MPI moabpar )
  set( MOABPAR_OBJECTS $<TARGET_OBJECTS:moabpar> )
  # find_package(MPI) sets MPI_LIBARY, not MPI_LIBRARIES
  if (MPI_LIBRARY AND NOT MPI_LIBRARIES)
    set(MPI_LIBRARIES ${MPI_LIBRARY})
  endif ()
  if (MPI_EXTRA_LIBRARY)
    list(APPEND MPI_LIBRARIES ${MPI_EXTRA_LIBRARY})
  endif ()
  # message(STATUS "MPI_LIBRARIES = ${MPI_LIBRARIES}.")
endif()

#Create the moab/EntityHandle.hpp file
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/moab/EntityHandle.hpp.in infile2)
string( REGEX REPLACE "#undef" "#cmakedefine" outstring2 "${infile2}" )
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/moab/EntityHandle.hpp.in" "${outstring2}")
configure_file(${CMAKE_CURRENT_BINARY_DIR}/moab/EntityHandle.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/moab/EntityHandle.hpp)

set(moab_link_lib)
message(STATUS "Adding io subdirectory.")
add_subdirectory(io)
message(STATUS "Adding IntxMesh subdirectory.")
add_subdirectory(IntxMesh)

if (ENABLE_MESQUITE AND MOAB_HAVE_CGM)
  #  add_subdirectory(mesquite)
endif(ENABLE_MESQUITE AND MOAB_HAVE_CGM)

if( MOAB_HAVE_HDF5 )
  include_directories(${HDF5_INCLUDES})
  set( MOAB_HDF_LIBS ${HDF5_LIBRARIES} )
endif()
if( MOAB_HAVE_NETCDF )
  include_directories(${NETCDF_INCLUDES})
  if ( MOAB_HAVE_MPI )
    set( MOAB_NETCDF_LIBS ${PNETCDF_LIBRARIES} ${NETCDF_LIBRARIES} )
  else ( MOAB_HAVE_MPI )
    set( MOAB_NETCDF_LIBS ${NETCDF_LIBRARIES} )
  endif ( MOAB_HAVE_MPI )
endif()


set(MOAB_LIB_SOURCES
        AdaptiveKDTree.cpp
        AEntityFactory.hpp AEntityFactory.cpp
        AffineXform.hpp    AffineXform.cpp
        AxisBox.hpp        AxisBox.cpp
        BitPage.hpp        BitPage.cpp
        BitTag.hpp         BitTag.cpp
        BoundBox.cpp
        BSPTree.cpp
        BSPTreePoly.cpp
        BVHTree.cpp
        CN.cpp
        CartVect.cpp
        Core.cpp
        DebugOutput.hpp DebugOutput.cpp
        DenseTag.hpp    DenseTag.cpp
        DualTool.cpp
        ElementSequence.hpp
        EntitySequence.hpp  EntitySequence.cpp
        ErrorHandler.cpp
        ErrorOutput.hpp  ErrorOutput.cpp
        Factory.cpp
        FBEngine.cpp
        FileOptions.cpp
        GeomUtil.cpp
        GeomTopoTool.cpp
	GeomQueryTool.cpp
        HalfFacetRep.cpp
        HigherOrderFactory.cpp
        HomXform.cpp
        iMOAB.cpp
        Internals.hpp
        LloydSmoother.cpp
        MBCNArrays.hpp
        MergeMesh.cpp
        MeshSet.hpp         MeshSet.cpp
        MeshSetSequence.hpp MeshSetSequence.cpp
        MeshTag.hpp         MeshTag.cpp
        MeshTopoUtil.cpp
        OrientedBox.cpp
        OrientedBoxTreeTool.cpp
        lotte/poly.c
        lotte/findpt.c
        lotte/errmem.c
        lotte/tensor.c
        LocalDiscretization/ElemEvaluator.cpp
        LocalDiscretization/LinearHex.cpp
        LocalDiscretization/LinearQuad.cpp
        LocalDiscretization/LinearTet.cpp
        LocalDiscretization/LinearTri.cpp
        LocalDiscretization/QuadraticHex.cpp
        MeshGeneration.cpp
        NestedRefine.cpp
        PolyElementSeq.hpp  PolyElementSeq.cpp
        ProgOptions.cpp
        Range.cpp
        RangeSeqIntersectIter.hpp RangeSeqIntersectIter.cpp
        ReadUtil.hpp              ReadUtil.cpp
        ReaderWriterSet.cpp
        ReorderTool.cpp
        ScdElementData.hpp        ScdElementData.cpp
        ScdInterface.cpp
        ScdVertexData.hpp         ScdVertexData.cpp
        SequenceData.hpp          SequenceData.cpp
        SequenceManager.hpp       SequenceManager.cpp
        SetIterator.cpp
        Skinner.cpp
        SmoothCurve.hpp           SmoothCurve.cpp
        SmoothFace.hpp            SmoothFace.cpp
        SparseTag.hpp             SparseTag.cpp
        SpatialLocator.cpp
        SpectralMeshTool.cpp
        StructuredElementSeq.hpp  StructuredElementSeq.cpp
        SweptElementData.hpp      SweptElementData.cpp
        SweptElementSeq.hpp       SweptElementSeq.cpp
        SweptVertexData.hpp       SweptVertexData.cpp
        SysUtil.hpp               SysUtil.cpp
        TagCompare.hpp
        TagInfo.hpp               TagInfo.cpp
        TupleList.cpp
        Tree.cpp
        Types.cpp
        TypeSequenceManager.hpp   TypeSequenceManager.cpp
        UnstructuredElemSeq.hpp   UnstructuredElemSeq.cpp
        Util.cpp
        VarLenDenseTag.hpp        VarLenDenseTag.cpp
        VarLenSparseTag.hpp       VarLenSparseTag.cpp
        VarLenTag.hpp
        VertexSequence.hpp        VertexSequence.cpp
        WriteUtil.hpp             WriteUtil.cpp
        verdict/v_vector.h
        verdict/V_EdgeMetric.cpp
        verdict/V_GaussIntegration.cpp
        verdict/V_HexMetric.cpp
        verdict/V_KnifeMetric.cpp
        verdict/V_PyramidMetric.cpp
        verdict/V_QuadMetric.cpp
        verdict/V_TetMetric.cpp
        verdict/V_TriMetric.cpp
        verdict/V_WedgeMetric.cpp
        verdict/VerdictVector.cpp
        verdict/VerdictWrapper.cpp
        verdict/verdict_defines.hpp
        verdict/VerdictVector.hpp
        verdict/V_GaussIntegration.hpp
        moab_mpe.h )

set( MOAB_INSTALL_HEADERS
        moab/AdaptiveKDTree.hpp
        moab/BoundBox.hpp
        moab/BSPTree.hpp
        moab/BSPTreePoly.hpp
        moab/BVHTree.hpp
        moab/CN.hpp
        moab/CartVect.hpp
        moab/Compiler.hpp
        moab/Core.hpp
        moab/CpuTimer.hpp
        moab/DualTool.hpp
        moab/Error.hpp
        moab/GeomTopoTool.hpp
        moab/GeomQueryTool.hpp
        moab/HalfFacetRep.hpp
        moab/HigherOrderFactory.hpp
        moab/HomXform.hpp
        moab/EntityType.hpp
        moab/ErrorHandler.hpp
        moab/FBEngine.hpp
        moab/FileOptions.hpp
        moab/FindPtFuncs.h
        moab/Forward.hpp
        moab/GeomUtil.hpp
        moab/iMOAB.h
        moab/imoab_protos.h
        moab/Interface.hpp
        moab/IntxMesh/Intx2Mesh.hpp
        moab/IntxMesh/IntxUtils.hpp
        moab/IntxMesh/Intx2MeshInPlane.hpp
        moab/IntxMesh/Intx2MeshOnSphere.hpp
        moab/IntxMesh/IntxRllCssphere.hpp
        moab/LloydSmoother.hpp
        moab/point_locater/tree/common_tree.hpp
        moab/point_locater/tree/element_tree.hpp
        moab/point_locater/tree/bvh_tree.hpp
        moab/point_locater/io.hpp
        moab/point_locater/element_maps/linear_hex_map.hpp
        moab/point_locater/element_maps/linear_tet_map.hpp
        moab/point_locater/element_maps/spectral_hex_map.hpp
        moab/point_locater/element_maps/quadratic_hex_map.hpp
        moab/point_locater/point_locater.hpp
        moab/point_locater/parametrizer.hpp
        moab/DiscreteGeometry/DGMSolver.hpp
        moab/DiscreteGeometry/HiReconstruction.hpp
        moab/ElemEvaluator.hpp
        moab/LocalDiscretization/LinearHex.hpp
        moab/LocalDiscretization/LinearQuad.hpp
        moab/LocalDiscretization/LinearTet.hpp
        moab/LocalDiscretization/LinearTri.hpp
        moab/LocalDiscretization/QuadraticHex.hpp
        moab/Matrix3.hpp
        moab/MergeMesh.hpp
        moab/MeshTopoUtil.hpp
        moab/MeshGeneration.hpp
        moab/OrientedBox.hpp
        moab/OrientedBoxTreeTool.hpp
        moab/PartitionerBase.hpp
        moab/ProgOptions.hpp
        moab/Range.hpp
        moab/RangeMap.hpp
        moab/ReadUtilIface.hpp
        moab/ReaderIface.hpp
        moab/ReaderWriterSet.hpp
        moab/ReorderTool.hpp
        moab/NestedRefine.hpp
        moab/NestedRefineTemplates.hpp
        moab/ScdInterface.hpp
        moab/SetIterator.hpp
        moab/Skinner.hpp
        moab/SpatialLocator.hpp
        moab/SpatialLocatorTimes.hpp
        moab/SpectralMeshTool.hpp
        moab/Tree.hpp
        moab/TreeStats.hpp
        moab/TupleList.hpp
        moab/Types.hpp
        moab/mhdf_public.h
        moab/UnknownInterface.hpp
        moab/Util.hpp
        moab/WriteUtilIface.hpp
        moab/WriterIface.hpp
        moab/verdict.h
        moab/verdict/VerdictWrapper.hpp
        moab/win32_config.h
        MBEntityType.h
        MBCN.h
        MBCN_protos.h
        MBTagConventions.hpp )

set( MOAB_GENERATED_INSTALL_HEADERS
     ${CMAKE_CURRENT_BINARY_DIR}/moab/EntityHandle.hpp
     ${CMAKE_CURRENT_BINARY_DIR}/moab/MOABConfig.h
     ${CMAKE_CURRENT_BINARY_DIR}/moab_export.h
  )

if( MOAB_HAVE_CGM )
  set( MOAB_CGM_LIBS ${CGM_LIBRARIES} )
  #message("src/cmake CGM_INCLUDES :: ${CGM_INCLUDES}")
  include_directories(${CGM_INCLUDES})
endif()

if (MOAB_HAVE_ZOLTAN)
  set( MOAB_LIB_SOURCES ${MOAB_LIB_SOURCES}
          ZoltanPartitioner.cpp )
  set( MOAB_INSTALL_HEADERS ${MOAB_INSTALL_HEADERS}
          moab/ZoltanPartitioner.hpp )
  include_directories( ${ZOLTAN_INCLUDES} )
  list(APPEND MOAB_DEP_LIBRARIES ${ZOLTAN_LIBRARIES})
endif()

if (MOAB_HAVE_METIS)
  set( MOAB_LIB_SOURCES ${MOAB_LIB_SOURCES}
        MetisPartitioner.cpp )
  set( MOAB_INSTALL_HEADERS ${MOAB_INSTALL_HEADERS}
        moab/MetisPartitioner.hpp )
  include_directories( ${METIS_INCLUDES} )
  list(APPEND MOAB_DEP_LIBRARIES ${METIS_LIBRARIES})
endif()

if (MOAB_HAVE_TEMPESTREMAP)
  set( MOAB_LIB_SOURCES ${MOAB_LIB_SOURCES} 
                        Remapping/TempestRemapper.cpp 
                        Remapping/TempestOnlineMap.cpp 
                        Remapping/TempestLinearRemap.cpp
                        Remapping/TempestOnlineMapIO.cpp 
                        )
  set( MOAB_INSTALL_HEADERS ${MOAB_INSTALL_HEADERS} 
        moab/Remapping/Remapper.hpp
        moab/Remapping/TempestRemapper.hpp
        moab/Remapping/TempestOnlineMap.hpp )

  include_directories( ${TEMPESTREMAP_INCLUDES} )
  list(APPEND MOAB_DEP_LIBRARIES ${TEMPESTREMAP_LIBRARIES})

endif (MOAB_HAVE_TEMPESTREMAP)

add_library(
  MOAB
  ${MOAB_LIB_SOURCES} ${MOAB_INSTALL_HEADERS} ${MOAB_GENERATED_INSTALL_HEADERS}
  $<TARGET_OBJECTS:moabio>
  $<TARGET_OBJECTS:moab_intx_mesh>
  ${MOABPAR_OBJECTS}
  ${MDHF_OBJ}
  )
include(CMakeLibraryFuncs)
SciFixupLibrary(MOAB MOAB MOAB)

target_include_directories(MOAB
  PUBLIC
  "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

generate_export_header(MOAB)

set_target_properties(
  MOAB
  PROPERTIES
  COMPILE_FLAGS "-DIS_BUILDING_MB ${MOAB_DEFINES}"
  CMAKE_SHARED_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}"
  VERSION ${MOAB_VERSION}
  SOVERSION ${MOAB_VERSION_MAJOR}
  )

message(STATUS "MOAB_LIBS = ${MOAB_LIBS}.")
set(MOAB_ALL_LIBS ${MOAB_DEP_LIBRARIES} ${MOAB_LIBS} ${MOAB_CGM_LIBS})
list(APPEND MOAB_ALL_LIBS "${MPI_LIBRARY}")
list(APPEND MOAB_ALL_LIBS ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(MOAB "${MOAB_ALL_LIBS}")

# If using clang-tidy, set the target property so that
# reformatting code does not use full fledged C++11 semantics
# set_property(TARGET MOAB PROPERTY CXX_STANDARD 98)

install(
  TARGETS MOAB
  EXPORT MOABTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
list(APPEND MOAB_INSTALL_TARGETS  MOAB)
include(AutoconfHeader)
moab_install_headers(${MOAB_INSTALL_HEADERS})
foreach (header ${MOAB_GENERATED_INSTALL_HEADERS})
    STRING(REGEX REPLACE "^${CMAKE_CURRENT_BINARY_DIR}/" "" relative ${header})
    string(REGEX MATCH "(.*)/" DIR ${relative})
    install(
      FILES ${header}
      DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${DIR}
      )
endforeach()

=== tools/CMakeLists.txt ===
# Documentation
# Optional tools
option ( MOAB_BUILD_MBCONVERT    "Build the MOAB mesh converter tool?"           ON )
option ( MOAB_BUILD_HEXMODOPS    "Build the hexahedral modops tool?"             ON )
option ( MOAB_BUILD_MBSIZE       "Build the mbsize tool?"                        ON )
option ( MOAB_BUILD_MBMERGE      "Build the mbmerge tool?"                       ON )
option ( MOAB_BUILD_MBMEM        "Build the mbmem tool?"                         ON )
option ( MOAB_BUILD_MBSKIN       "Build the mbskin tool?"                        ON )
option ( MOAB_BUILD_MBDEPTH      "Build the mbdepth tool?"                       ON )
option ( MOAB_BUILD_MBTAGPROP    "Build the mbtagprop tool?"                     ON )
option ( MOAB_BUILD_MBGSETS      "Build the mbgsets tool?"                       ON )
option ( MOAB_BUILD_SPHEREDECOMP "Build the sphere decomposition tool?"          ON )
option ( MOAB_BUILD_MBSURFPLOT   "Build the mbsurfplot application?"             ON )
option ( MOAB_BUILD_SPHEREDECOMP "Build the spheredecomp application?"           ON )
option ( MOAB_BUILD_MBPART       "Build the mbpart (Zoltan-based) partitioner?" OFF )
option ( MOAB_BUILD_MBSLAVEPART  "Build the slave partitioner tool?"             ON )
option ( MOAB_BUILD_MBCOUPLER    "Build the mesh coupler tool?"                  ON )
option ( MOAB_BUILD_MBHONODES    "Build the hex8 to hex27 converter tool?"       ON )
option ( MOAB_BUILD_MBUMR        "Build the uniform mesh refinement tool?"       ON )
option ( MOAB_BUILD_MBQUALITY    "Build the quality metrics tool?"               ON )
option ( MOAB_BUILD_MBTEMPEST    "Build the TempestRemap coupler tool?"         OFF )

if ( MOAB_HAVE_MPI AND MPI_FOUND )
  add_subdirectory( refiner )
endif ( )

if (ENABLE_MESQUITE AND MOAB_HAVE_CGM)
  # add_subdirectory(mesquite)
endif(ENABLE_MESQUITE AND MOAB_HAVE_CGM)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_BINARY_DIR}/src/parallel
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/parallel
  ${CMAKE_CURRENT_SOURCE_DIR}
)

if (MOAB_HAVE_TEMPESTREMAP)
  include_directories( ${TEMPESTREMAP_INCLUDES} ${EIGEN3_DIR} )
endif (MOAB_HAVE_TEMPESTREMAP)

set( TOOLS_LINK_LIBS MOAB ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
if ( MOAB_HAVE_CGM )
  set( TOOLS_LINK_LIBS ${TOOLS_LINK_LIBS} ${CGM_LIBRARIES} )
  add_subdirectory( geometry )
endif ( MOAB_HAVE_CGM )

# COMPAREFILES
if ( MOAB_HAVE_HDF5 )
  add_executable( compareFiles compareFiles.cpp)
  set_source_files_properties( compareFiles.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( compareFiles ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_COMPAREFILES 1 )
  install(
    TARGETS compareFiles
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ( MOAB_HAVE_HDF5 )

# MBSIZE
if ( MOAB_BUILD_MBSIZE )
  add_executable( mbsize size.cpp measure.cpp)
  set_source_files_properties( size.cpp measure.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbsize ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBSIZE 1 )
  install(
    TARGETS mbsize
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.mbsize)
endif ( )

# MBMERGE
if ( MOAB_BUILD_MBMERGE )
  add_executable( mbmerge merge.cpp)
  set_source_files_properties( merge.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbmerge ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBMERGE 1 )
  install(
    TARGETS mbmerge
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ( )



# MBMEM
if ( MOAB_BUILD_MBMEM )
  add_executable( mbmem mbmem.cpp)
  set_source_files_properties( mbmem.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbmem ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBMEM 1 )
  install(
    TARGETS mbmem
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ( )

# MBCONVERT
if ( MOAB_BUILD_MBCONVERT )
  add_executable( mbconvert convert.cpp)
  set_source_files_properties( convert.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbconvert ${TOOLS_LINK_LIBS} ${TEMPESTREMAP_LIBRARIES} )
  set( MOAB_HAVE_MBCONVERT 1 )
  install(
    TARGETS mbconvert
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.mbconvert)
  INSTALL(FILES mbconvert.man DESTINATION share/man/man1 RENAME mbconvert.1)
endif ( )

# MBHONODES
if ( MOAB_BUILD_MBHONODES )
  add_executable( mbhonodes honodes.cpp)
  set_source_files_properties( honodes.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbhonodes ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBHONODES 1 )
  install(
    TARGETS mbhonodes
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ( )

# MBDEPTH
if ( MOAB_BUILD_MBDEPTH )
  add_executable( mbdepth depth.cpp)
  set_source_files_properties( depth.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbdepth ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBDEPTH 1 )
  install(
    TARGETS mbdepth
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ( )

# MBSKIN
if ( MOAB_BUILD_MBSKIN )
  add_executable( mbskin skin.cpp)
  set_source_files_properties( skin.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbskin ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBSKIN 1 )
  install(
    TARGETS mbskin
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.mbskin)
endif ( )

# MBSURFPLOT
if ( MOAB_BUILD_MBSURFPLOT )
  add_executable( mbsurfplot surfplot.cpp )
  set_source_files_properties( surfplot.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbsurfplot ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBSURFPLOT 1 )
  install(
    TARGETS mbsurfplot
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.mbsurfplot)
endif ( )

# MBTAGPROP
if ( MOAB_BUILD_MBTAGPROP )
  add_executable( mbtagprop parse.cpp propagate_tags.cpp  )
  set_source_files_properties( parse.cpp propagate_tags.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbtagprop ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBTAGPROP 1 )
  install(
    TARGETS mbtagprop
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.mbtagprop)
endif ( )

# MBGSETS
if ( MOAB_BUILD_MBGSETS )
  add_executable( mbgsets gsets.cpp )
  set_source_files_properties( gsets.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbgsets ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBGSETS 1 )
  install(
    TARGETS mbgsets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif( )

# MBUMR
if ( MOAB_BUILD_MBUMR )
  add_executable( mbumr umr.cpp )
  set_source_files_properties( umr.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbumr ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBUMR 1 )
  install(
    TARGETS mbumr
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif( )

# MBSLAVEPART
if ( MOAB_BUILD_MBSLAVEPART )
  add_executable( mbslavepart mbslavepart.cpp)
  set_source_files_properties( mbslavepart.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbslavepart ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBSLAVEPART 1 )
  install(
    TARGETS mbslavepart
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif( )

# MBTEMPEST
if ( MOAB_BUILD_MBTEMPEST )
  add_executable( mbtempest mbtempest.cpp)
  set_source_files_properties( mbtempest.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbtempest ${TOOLS_LINK_LIBS} ${TEMPESTREMAP_LIBRARIES} )
  set( MOAB_HAVE_MBTEMPEST 1 )
  install(
    TARGETS mbtempest
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )

endif( )

# MBQUALITY
if ( MOAB_BUILD_MBQUALITY )
  add_executable( mbquality quality.cpp )
  set_source_files_properties( quality.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbquality ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_MBQUALITY 1 )
  install(
    TARGETS mbquality
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif( )

# Zoltan
if ( MOAB_BUILD_MBPART OR ( MOAB_HAVE_ZOLTAN OR MOAB_HAVE_METIS ) )
  set(MOAB_BUILD_MBPART ON)
  # Build the mbpart executable
  add_executable( mbpart mbpart.cpp )
  include_directories( ${ZOLTAN_INCLUDES} ${PARMETIS_INCLUDES} ${METIS_INCLUDES} )
  if (MOAB_HAVE_CGM)
    include_directories( ${CGM_INCLUDES} )
  endif (MOAB_HAVE_CGM)
  set_source_files_properties( mbpart.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( mbpart ${TOOLS_LINK_LIBS} ${ZOLTAN_LIBRARIES} ${PARMETIS_LIBRARIES} ${METIS_LIBRARIES} )
  set( MOAB_HAVE_MBPART 1 )
  install(
    TARGETS mbpart
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ( MOAB_BUILD_MBPART OR ( MOAB_HAVE_ZOLTAN OR MOAB_HAVE_METIS ) )

# MBCoupler
if ( ENABLE_IMESH AND MOAB_HAVE_MPI AND MPI_FOUND AND MOAB_BUILD_MBCOUPLER )
  add_subdirectory( mbcoupler )
endif ( )

# hexmodops
if( MOAB_BUILD_HEXMODOPS )
  add_executable( hexmodops makeops.cpp )
  target_link_libraries( hexmodops ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_HEXMODOPS 1 )
  install(
    TARGETS hexmodops
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.hexmodops)
endif()

# MBSPHEREDECOMP
if ( MOAB_BUILD_SPHEREDECOMP )
  add_executable( spheredecomp SphereDecomp.cpp SphereDecomp.hpp sphere_decomp.cpp )
  set_source_files_properties( SphereDecomp.cpp SphereDecomp.hpp sphere_decomp.cpp COMPILE_FLAGS "${MOAB_DEFINES}" )
  target_link_libraries( spheredecomp ${TOOLS_LINK_LIBS} )
  set( MOAB_HAVE_SPHEREDECOMP 1 )
  install(
    TARGETS spheredecomp
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  SET(MOAB_DOCS ${MOAB_DOCS} README.spheredecomp)
endif ( )

install(FILES ${MOAB_DOCS} DESTINATION share/doc/moab)

=== itaps/irel/CMakeLists.txt ===
set ( MOAB_IREL_SRCS
          ArrayManager.hpp
          AssocPair.cpp
          AssocPair.hpp
          AssocPairSide.hpp
          iRel_Lasso.hpp
          iRel_Lasso.cpp
          Lasso.hpp
          Lasso.cpp
    )
set ( MOAB_IREL_LIB_INCLUDES
          iRel.h
          iRel_f.h
          iRel_protos.h
    )

set (MOAB_DEFINES "")

set(IREL_LINK_LIBS )
if (ENABLE_CGM)
  include_directories( ${CGM_INCLUDES} )
  set (MOAB_DEFINES "-DENABLE_IGEOM ${MOAB_DEFINES}")
  set(IREL_LINK_LIBS ${IGEOM_LIBS} ${CGM_LIBRARIES})

  set(MOAB_IREL_SRCS ${MOAB_IREL_SRCS}
                    GeomAssocPairSide.cpp
                    GeomAssocPairSide.hpp
      )
endif()

set(IREL_LINK_LIBS MOAB ${IREL_LINK_LIBS})
if (ENABLE_FBIGEOM)
  include_directories( ${CMAKE_SOURCE_DIR}/itaps/fbigeom ${CMAKE_BINARY_DIR}/itaps/fbigeom )
  set (MOAB_DEFINES "-DENABLE_FBIGEOM ${MOAB_DEFINES}")
  set(IREL_LINK_LIBS FBiGeomMOAB ${IREL_LINK_LIBS})
  set(MOAB_IREL_SRCS ${MOAB_IREL_SRCS}
                     FBGeomAssocPairSide.cpp
                     FBGeomAssocPairSide.hpp
      )
endif()

if (ENABLE_IMESH)
  include_directories( ${CMAKE_SOURCE_DIR}/itaps/imesh ${CMAKE_BINARY_DIR}/itaps/imesh )
  set (MOAB_DEFINES "-DENABLE_IMESH ${MOAB_DEFINES}")
  set(IREL_LINK_LIBS iMesh ${IREL_LINK_LIBS})
  set(MOAB_IREL_SRCS ${MOAB_IREL_SRCS}
                     MeshAssocPairSide.cpp
                     MeshAssocPairSide.hpp
    )
endif()

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/itaps
  ${CMAKE_BINARY_DIR}/itaps
  )

if ( MOAB_HAVE_MPI )
  include_directories( ${CMAKE_SOURCE_DIR}/src/parallel
                       ${CMAKE_BINARY_DIR}/src/parallel)
endif ()

if ( MOAB_HAVE_HDF5 AND HDF5_FOUND )
  include_directories( ${HDF5_INCLUDE_DIRECTORIES}
                       ${CMAKE_SOURCE_DIR}/src/io/mhdf/include )
endif( )

set_source_files_properties(
  ${MOAB_IREL_SRCS} COMPILE_FLAGS "${MOAB_DEFINES}"
  )

add_library(
  iRel
  ${MOAB_IREL_SRCS}
  ${MOAB_IREL_LIB_INCLUDES}
  )

target_link_libraries( iRel ${IREL_LINK_LIBS} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )

set_target_properties(
  iRel
  PROPERTIES
  VERSION ${MOAB_VERSION}
  SOVERSION ${MOAB_VERSION_MAJOR}
  )

install(
  TARGETS iRel
  EXPORT MOABTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
set( MOAB_INSTALL_TARGETS ${MOAB_INSTALL_TARGETS} iRel)

install(
  FILES ${MOAB_IREL_LIB_INCLUDES}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

=== src/parallel/CMakeLists.txt ===
set( moab_PARALLEL_SRCS
  ParallelComm.cpp
  ProcConfig.cpp
  ParallelData.cpp
  ParallelMergeMesh.cpp
  ReadParallel.hpp      ReadParallel.cpp
  SharedSetData.hpp     SharedSetData.cpp
  ParCommGraph.cpp
  gs.cpp
)

#generate the moab_mpi_config.h file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/moab_mpi_config.h.in "${CMAKE_CURRENT_BINARY_DIR}/moab_mpi_config.h" @ONLY)

set(moab_PARALLEL_INSTALL_HDRS moab/gs.hpp
                               moab_mpi.h
                               moab/ParallelComm.hpp
                               moab/ParallelMergeMesh.hpp
                               moab/ProcConfig.hpp
                               moab/ParallelData.hpp
                               moab/ParCommGraph.hpp
                               MBParallelConventions.h )

set( MOAB_GENERATED_INSTALL_PHEADERS
     ${CMAKE_CURRENT_BINARY_DIR}/moab_mpi_config.h )

include_directories(
    ${MOAB_BINARY_DIR}/src
    ${MOAB_SOURCE_DIR}/src
    ${MOAB_SOURCE_DIR}/src/parallel
    ${CMAKE_CURRENT_BINARY_DIR}
  )

if ( MOAB_HAVE_HDF5 AND MOAB_HAVE_HDF5_PARALLEL )
  set( moab_PARALLEL_SRCS ${moab_PARALLEL_SRCS}
                          WriteHDF5Parallel.cpp
                          WriteHDF5Parallel.hpp )
endif()

if ( MOAB_HAVE_HDF5 )
  include_directories(
    ${HDF5_INCLUDES}
    ${MOAB_SOURCE_DIR}/mhdf/include
  )
endif ( MOAB_HAVE_HDF5 )

if ( MOAB_HAVE_ZOLTAN )
  include_directories( ${ZOLTAN_INCLUDE_DIR} )
endif ( MOAB_HAVE_ZOLTAN )

set_source_files_properties( ${moab_PARALLEL_SRCS}
  COMPILE_FLAGS "-DIS_BUILDING_MB -DSRCDIR=\"${MOAB_SOURCE_DIR}\" ${MOAB_DEFINES}"
)

add_library(
  moabpar
  OBJECT ${moab_PARALLEL_INSTALL_HDRS} ${MOAB_GENERATED_INSTALL_PHEADERS} ${moab_PARALLEL_SRCS}
  )

include(AutoconfHeader)
moab_install_headers(${moab_PARALLEL_INSTALL_HDRS})
foreach (header ${MOAB_GENERATED_INSTALL_PHEADERS})
    STRING(REGEX REPLACE "^${CMAKE_CURRENT_BINARY_DIR}/" "" relative ${header})
    string(REGEX MATCH "(.*)/" DIR ${relative})
    install(
      FILES ${header}
      DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${DIR}
      )
endforeach()

=== test/obb/CMakeLists.txt ===
set(TEST_COMP_FLAGS "-DMESHDIR=${MOAB_ABSSRC_DIR}/MeshFiles/unittest -DSRCDIR=${CMAKE_CURRENT_SOURCE_DIR}")

set( TESTS obb_test.cpp)

foreach( fname ${TESTS} )
  string( REPLACE ".cpp" "" tmp ${fname} )
  string( REPLACE ".cc" "" base ${tmp} )
  add_executable( ${base} ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp ${fname})
  set_target_properties( ${base} PROPERTIES COMPILE_FLAGS "${TEST_COMP_FLAGS} ${MOAB_DEFINES} -DTEST" )
  target_link_libraries( ${base} MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
  add_test( ${base} ${EXECUTABLE_OUTPUT_PATH}/${base} )
endforeach()

add_executable( obb_time obb_time.cpp)
set_target_properties( obb_time PROPERTIES COMPILE_FLAGS "${MOAB_DEFINES}" )
target_link_libraries( obb_time MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )

add_executable( obb_tree_tool obb_tree_tool.cpp)
set_target_properties( obb_tree_tool PROPERTIES COMPILE_FLAGS "${MOAB_DEFINES}" )
target_link_libraries( obb_tree_tool MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )

=== tools/mesquite/CMakeLists.txt ===

#
# B) Define the header and source files (and directories)
#

SET(HEADERS "")
SET(SOURCES "")

SET(SOURCES ${SOURCES}
  CLArgs.cpp
  CLArgFlag.cpp
  ManPage.cpp
  CLArgs.hpp
  CLArgFlag.hpp
  ManPage.hpp
  domain.hpp
  domain.cpp
  )

IF (TPL_ENABLE_MPI)

ENDIF()

#
# C) Define the targets for package's library(s)
#

IF (NOT ${PROJECT_NAME} STREQUAL "Mesquite")

  ADD_LIBRARY( msqutil STATIC ${SOURCES} ${HEADERS} )
#  TRIBITS_ADD_LIBRARY(
#    msqutil
#    HEADERS ${HEADERS}
#    SOURCES ${SOURCES}
#    )

  add_executable(
    vtkrandom
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES randomize.cpp
    )

  add_executable(
    msqshape
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES shape-improve.cpp
    )

  add_executable(
    vtkxform
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES transform.cpp
    )

  add_executable(
    msqquality
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES quality.cpp
            domain.hpp
            domain.cpp
    )

ELSE()

  ADD_LIBRARY( msqutil STATIC ${SOURCES} ${HEADERS} )
  ADD_EXECUTABLE( vtkrandom randomize.cpp domain.cpp )
  ADD_EXECUTABLE( msqshape  shape-improve.cpp domain.cpp )
  ADD_EXECUTABLE( vtkxform  transform.cpp )
  ADD_EXECUTABLE( msqquality quality.cpp )

ENDIF()

TARGET_LINK_LIBRARIES( vtkrandom  msqutil mesquite )
TARGET_LINK_LIBRARIES( msqshape   msqutil mesquite )
TARGET_LINK_LIBRARIES( vtkxform   msqutil mesquite )
TARGET_LINK_LIBRARIES( msqquality msqutil mesquite )

IF(${PACKAGE_NAME}_ENABLE_SHARED)
  SET( MESQUITE_UTIL_DEFINES "${MESQUITE_DEFINES}" )
ELSE()
  SET( MESQUITE_UTIL_DEFINES "${MESQUITE_DEFINES} -DMESQUITE_STATIC_LIB" )
ENDIF()
SET( UTIL_SOURCES
     CLArgFlag.cpp
     CLArgs.cpp
     domain.cpp
     ManPage.cpp
     quality.cpp
     randomize.cpp
     shape-improve.cpp
     transform.cpp )
SET_SOURCE_FILES_PROPERTIES( ${UTIL_SOURCES} COMPILE_FLAGS ${MESQUITE_UTIL_DEFINES} )

=== tools/refiner/CMakeLists.txt ===
set ( MOAB_REFINER_SRCS
  EdgeSizeEvaluator.cpp
  EdgeSizeSimpleImplicit.cpp
  EntityRefiner.cpp
  MeshOutputFunctor.cpp
  MeshRefiner.cpp
  ProcessSet.cpp
  RefinerTagManager.cpp
  SimplexTemplateRefiner.cpp
  SimplexTemplateTagAssigner.cpp
  SplitVertices.cpp
  )

include_directories(
    ${MOAB_BINARY_DIR}
    ${MOAB_BINARY_DIR}/src
    ${MOAB_BINARY_DIR}/src/parallel
    ${MOAB_SOURCE_DIR}/src
    ${MOAB_SOURCE_DIR}/src/parallel
    ${MOAB_SOURCE_DIR}/test
    ${CMAKE_CURRENT_SOURCE_DIR}
)

set_source_files_properties(
  ${MOAB_REFINER_SRCS}
  COMPILE_FLAGS "${MOAB_DEFINES}"
)

add_library( MOABrefiner
  ${MOAB_REFINER_SRCS}
  )
target_link_libraries( MOABrefiner MOAB ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
if ( MOAB_HAVE_MPI )
  target_link_libraries( MOABrefiner ${MPI_LIBRARIES} )
endif ( MOAB_HAVE_MPI )

enable_testing()

add_executable( test_mesh_refiner test_mesh_refiner.cpp )
set_source_files_properties( test_mesh_refiner.cpp
  COMPILE_FLAGS "-DTEST ${MOAB_DEFINES} -DMESHDIR=${MOAB_ABSSRC_DIR}/MeshFiles/unittest" )
target_link_libraries( test_mesh_refiner MOAB MOABrefiner ${CGM_LIBRARIES})

add_test( TestMeshRefiner
  ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS}
  ${EXECUTABLE_OUTPUT_PATH}/test_mesh_refiner ${MPIEXEC_POSTFLAGS}
  ${MOAB_SOURCE_DIR}/tools/refiner/fourVolsBare.cub )

=== PKGBUILD ===
# Maintainer: Rafal Brzegowy <rafal.brzegowy@yahoo.com>

_realname=moab
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.3.1
pkgrel=3
pkgdesc='The Mesh-Oriented datABase MOAB is a component for representing and evaluating mesh data (mingw-w64)'
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
depends=("${MINGW_PACKAGE_PREFIX}-eigen3"
         "${MINGW_PACKAGE_PREFIX}-msmpi"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
license=('spdx:LGPL-3.0+')
url='https://sigma.mcs.anl.gov/moab-library/'
source=(https://ftp.mcs.anl.gov/pub/fathom/${_realname}-${pkgver}.tar.gz
        "0001-no-fortran.patch")
sha256sums=('2404fab2d84f87be72b57cfef5ea237bfa444aaca059e66a158f22134956fe54'
            '2669507edebea057297ef7fb4e4ced4e5bc2ac350da78b24ac51a7bcb3559a94')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${srcdir}/${_realname}-${pkgver}
  apply_patch_with_msg \
    0001-no-fortran.patch
}

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _extra_cmake_flags+=" -DENABLE_FORTRAN=OFF"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_BUILD_TYPE=Release \
      -DBUILD_SHARED_LIBS=OFF \
      -DENABLE_MPI=ON \
      -DENABLE_TESTING=ON \
      ${_extra_cmake_flags} \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} cmake --build . --target install
  install -Dm644 ${srcdir}/${_realname}-${pkgver}/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# parallel tests, cf.
# <https://lists.debian.org/debian-science/2015/05/msg00054.html>
export OMPI_MCA_orte_rsh_agent=/bin/false

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
  -DCMAKE_C_COMPILER=mpicc \
  -DCMAKE_CXX_COMPILER=mpicxx \
  -DCMAKE_Fortran_COMPILER=mpif90 \
  -DMOAB_BUILD_MBPART:BOOL=ON \
  -DENABLE_FBIGEOM:BOOL=ON \
  -DENABLE_HDF5:BOOL=ON \
  -DENABLE_IMESH:BOOL=ON \
  -DENABLE_METIS:BOOL=ON \
  -DENABLE_PARMETIS:BOOL=ON \
  -DENABLE_MPI:BOOL=ON
